local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

local lastPanel
local displayString = "---"
local _hex
local Lang = GetLocale()
local red = "|cffb11919"
local GetTime = GetTime
--local sName = L["Reincarnation"]
local sName, _, icon, _, _, _ = GetSpellInfo(20608)
--local sName = name
local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
local version = GetAddOnMetadata("ElvUI_ReincarnationDatatext", "Version")

--if E.myclass ~= "SHAMAN" then return end
local function OnUpdate(self)
	if E.myclass == "SHAMAN" then
		local s, d = GetSpellCooldown(sName)
		if s > 0 and d > 0 then 
			self.text:SetFormattedText(texture.." "..red..format("%d:%02d", floor((d-(GetTime()-s))/60), floor((d-(GetTime()-s))%60)).."|r")
		else
			self.text:SetFormattedText(texture.." ".._hex..L["Ready"].."!|r")
		end
	end
end

local function OnEvent(self, event, timerType, timeSeconds, totalTime)
	if E.myclass == "SHAMAN" then
		local isKnown = IsSpellKnown(20608, false)
		if (not isKnown) then
			self.text:SetFormattedText(_hex..sName.."|r "..L["Not learned!"])
		else
			if(event == "SPELL_UPDATE_COOLDOWN") then
				self:SetScript("OnUpdate", OnUpdate)
			elseif(not self.text:GetText()) then
				local s, d = GetSpellCooldown(sName)
				if s > 0 and d > 0 then 
					self.text:SetFormattedText(texture.." "..red..format("%d:%02d", floor((d-(GetTime()-s))/60), floor((d-(GetTime()-s))%60)).."|r")
				else
					self.text:SetFormattedText(texture.." ".._hex..L["Ready"].."!|r")
				end
			end
		end
	else
		self.text:SetFormattedText(red..L["Datatext disabled"].."!|r")
	end
	lastPanel = self
end

local function OnEnter(self)
	if not InCombatLockdown() then
		local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b
		DT:SetupTooltip(self)
		if E.myclass == "SHAMAN" then
			DT.tooltip:AddDoubleLine(L["Click"], L["Report"], r1, g1, b1, r2, g2, b2)
		else
			DT.tooltip:AddLine(L["Not Shaman"], r1, g1, b1)
		end
		DT.tooltip:Show()
	else
		DT.tooltip:Hide()
	end
	if lastPanel ~= nil then OnEvent(lastPanel) end
end

local function OnClick(self)
	if E.myclass == "SHAMAN" then
		local inInstance, instanceType = IsInInstance()
		local s, d = GetSpellCooldown(sName)
		local message = L["Reincarnation"]..": "..format("%d:%02d", floor((d-(GetTime()-s))/60), floor((d-(GetTime()-s))%60)).." "..L["remaining"].."!";
		local message2 = L["Reincarnation"]..": "..L["Ready"].."!";

		if s > 0 and d > 0 then 
			if instanceType == "raid" then
				SendChatMessage(message , "RAID", nil, nil)
			elseif instanceType == "party" then
				SendChatMessage(message , "PARTY", nil, nil)
			end
		else
			if instanceType == "raid" then
				SendChatMessage(message2 , "RAID", nil, nil)
			elseif instanceType == "party" then
				SendChatMessage(message2 , "PARTY", nil, nil)
			end
		end
	end
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then OnEvent(lastPanel) end
end
E["valueColorUpdateFuncs"][ValueColorUpdate] = true

DT:RegisterDatatext("Reincarnation", {"PLAYER_ENTERING_WORLD", "SPELL_UPDATE_COOLDOWN"}, OnEvent, OnUpdate, OnClick, OnEnter)

--[[
/run local i = 1; while true do local spellName, spellSubName = GetSpellBookItemName(20608, "spell"); if not spellName then do break end; end; DEFAULT_CHAT_FRAME:AddMessage( spellName .. '(' .. spellSubName .. ')' ) i = i + 1 end
]]
